/////////////////////////////////////////////////////////////////////////////
//
// wmp_goom.h : Declaration of the CWmp_goom
//
/////////////////////////////////////////////////////////////////////////////

#ifndef __WMP_GOOM_H_
#define __WMP_GOOM_H_

#include "resource.h"
#include "effects.h"

// preset values
enum {
    PRESET_320_240 = 0,
    PRESET_480_360,
    PRESET_640_480,
    PRESET_800_600,
    PRESET_COUNT
};

class RegSettings;
class SleepMgr;

/////////////////////////////////////////////////////////////////////////////
// CWmp_goom
class ATL_NO_VTABLE CWmp_goom : 
    public CComObjectRootEx<CComSingleThreadModel>,
    public CComCoClass<CWmp_goom, &CLSID_Wmp_goom>,
    public IDispatchImpl<IWmp_goom, &IID_IWmp_goom, &LIBID_WMP_GOOMLib>,
    public IWMPEffects
{
private:
    COLORREF    m_clrForeground;    // foreground color
    LONG        m_nPreset;          // current preset

    HRESULT WzToColor(const WCHAR *pwszColor, COLORREF *pcrColor);
    HRESULT ColorToWz( BSTR* pbstrColor, COLORREF crColor);
    DWORD SwapBytes(DWORD dwRet);

//	char bitmapbuffer[sizeof(BITMAPINFO)+260*4];
//	BITMAPINFO *bitmap_header;
public:
	bool bitmapInit;
	char bitmapbuffer[sizeof(BITMAPINFO)+260*4];
	BITMAPINFO *bitmap_header;
	int surface_width;
	int surface_height;
	bool bFullScreen;
	bool bChangeFS;
	bool bSetRender;
	HWND render_wnd;
	bool bQuit;
	HANDLE hThread;
	char *songTitle1;
	char *songSave;
	char *songSave_mem;
	int pngw[0x100];
	int pngh[0x100];
	unsigned int **pngbuf[0x100];
	bool fontloaded;
	HWND parent_wnd;
	RegSettings *regset;
	SleepMgr *sleeper;
	HWND cacheHwnd;
	bool dorender;
	int xgoom_render_pcm(int idx, HDC hdc, RECT *prc);
	int lastxr;
	int lastyr;
	int lastcs;
	bool xgoom_first;
	bool goomOwner;
	void LoadFont();

public:
    CWmp_goom();
    ~CWmp_goom();

DECLARE_REGISTRY_RESOURCEID(IDR_WMP_GOOM)

DECLARE_PROTECT_FINAL_CONSTRUCT()

BEGIN_COM_MAP(CWmp_goom)
    COM_INTERFACE_ENTRY(IWmp_goom)
    COM_INTERFACE_ENTRY(IDispatch)
    COM_INTERFACE_ENTRY(IWMPEffects)
END_COM_MAP()

public:

    // CComCoClass Overrides
    HRESULT FinalConstruct();
    void FinalRelease();

    // IWmp_goom
    STDMETHOD(get_foregroundColor)(/*[out, retval]*/ BSTR *pVal);
    STDMETHOD(put_foregroundColor)(/*[in]*/ BSTR newVal);

    // IEffects
    STDMETHOD(Render)(TimedLevel *pLevels, HDC hdc, RECT *rc);
    STDMETHOD(MediaInfo)(LONG lChannelCount, LONG lSampleRate, BSTR bstrTitle);
    STDMETHOD(GetCapabilities)(DWORD * pdwCapabilities);
    STDMETHOD(GoFullscreen)(BOOL fFullScreen);
    STDMETHOD(RenderFullScreen)(TimedLevel *pLevels);
    STDMETHOD(DisplayPropertyPage)(HWND hwndOwner);
    STDMETHOD(GetTitle)(BSTR *bstrTitle);
    STDMETHOD(GetPresetTitle)(LONG nPreset, BSTR *bstrPresetTitle);
    STDMETHOD(GetPresetCount)(LONG *pnPresetCount);
    STDMETHOD(SetCurrentPreset)(LONG nPreset);
    STDMETHOD(GetCurrentPreset)(LONG *pnPreset);
};

#endif //__WMP_GOOM_H_
